function [k2] = BN(X,kmax);
  T=size(X,1); N=size(X,2);   % Read dimensionality, T=Rows, N = Cols 
  X = X - ones(T,1)*mean(X);  % Subtract time series mean
  if T > N; X=X'; end;        % Always choose small dimensional covariance matrix  
  XX=X*X'/(T*N);              % Covariance matrix 
  [ve,va,ve1]=svd(XX');       % Single Value Decomposition: eigenvector, eignevalue, error

  m = size(XX,1);
  v0 = zeros(kmax+1,1);
   for i = 1:kmax+1;
    v0(i,:) = sum(sum(va(i:m,i:m)));
   end;
 
  ks = 0:kmax; ks = ks';

  c = min([N;T]);
  ic1 = log(v0) + ks.*((N+T)/(N*T))*log((N*T)/(2*(N+T)));
  ic2 = log(v0) + ks.*((N+T)/(N*T))*log(c); 
  ic3 = log(v0) + ks.*(log(c)/c); 
      
  k1 = find(ic1==min(ic1))-1;
  k2 = find(ic2==min(ic2))-1;
  k3 = find(ic3==min(ic3))-1;
  