clear;clc;
load cpi99_MAT.csv;           p = cpi99_MAT;
load spot99_MA_MAT.csv;   spot  = spot99_MA_MAT;
[T,n] = size(p);
s = log(spot(:,3:n));
ds = s(2:T,:) - s(1:T-1,:);

p = log(p(:,2:n-1)./(repmat(p(:,n),1,27)));
dp = p(2:T,:)-p(1:T-1,:);
su = log(spot(:,3:n+1));
seu = [su(:,1:6) su(:,8:28)];
seu = seu - repmat(su(:,7),1,27);
deu = seu(2:T,:) - seu(1:T-1,:);

%========= Finding the factor number to inflation rates
[T2,n2] = size(dp);
d2p = dp(2:T2,:) - dp(1:T2-1,:);
ic2=[];
for i=1:50;
  sdp = dp(i:T-1,:)./repmat(sqrt(var(dp)),T-i,1);
  sd2p = d2p(i:T2-1,:)./repmat(sqrt(var(d2p)),T2-i,1);
  k1 = BN(sdp,8);  k2 = BN(sd2p,8);
  ic2 = [ic2; k1 k2];
end

mdus = mean(ds,2); mdeu = mean(deu,2); mdp = mean(dp,2);
 
%====== CCE
xx1 = [ones(T-1,1) mdp mdus];
dsc = ds - xx1*inv(xx1'*xx1)*xx1'*ds;
dpc = dp - xx1*inv(xx1'*xx1)*xx1'*dp;
bcce1 = sum(sum(dsc.*dpc))/sum(sum(dpc.*dpc));

xx2 = [ones(T-1,1) mdp mdus mdeu];
dsc = ds - xx2*inv(xx2'*xx2)*xx2'*ds;
dpc = dp - xx2*inv(xx2'*xx2)*xx2'*dp;
bcce2 = sum(sum(dsc.*dpc))/sum(sum(dpc.*dpc));

% GHS method ============
sds = ds./repmat(sqrt(var(ds)),T-1,1);
sdp = dp./repmat(sqrt(var(dp)),T-1,1);
 [fs,ls,es,vs] = pc(sds,2);
 [fp,lp,ep,vp] = pc(sdp,1);

 ff = [ones(T-1,1) fs fp];
 y3 = ds - ff*inv(ff'*ff)*ff'*ds;
 x3 = dp - ff*inv(ff'*ff)*ff'*dp;
 be1 = sum(sum(x3.*y3))/sum(sum(x3.*x3));
 
 ff = [ones(T-1,1) fs fp mdp mdus mdeu];
 y3 = ds - ff*inv(ff'*ff)*ff'*ds;
 x3 = dp - ff*inv(ff'*ff)*ff'*dp;
 be3 = sum(sum(x3.*y3))/sum(sum(x3.*x3));
 
%Panel Robust t-ratio =====
re = y3 - x3*be3;
re = re.*x3;
xq = sum(re)'; xq = xq'*xq; invxx = 1/sum(sum(x3.*x3));
xq = invxx*xq*invxx;
xq = sqrt(diag(xq));
tr = be3./xq;
[be3 tr]

% Iterative PC: Bai's Estimator ====

% Run and get the residuals
bb = be3;

for i = 1:500;
  rs = ds - dp*bb;
  rss = rs./repmat(sqrt(var(rs)),T-1,1);
  k3 = BN(rss,8);
  [fr,lr,er,vr] = pc(rs,k3);
  ff = [ones(T-1,1) fr];
  [ff]
  pause
  ff = [ones(T-1,1) fr mdp mdus mdeu];
  y4 = ds - ff*inv(ff'*ff)*ff'*ds;
  x4 = dp - ff*inv(ff'*ff)*ff'*dp;
  be4 = sum(sum(x4.*y4))/sum(sum(x4.*x4));
   if abs(be4-bb) < 0.0000000001; break; end
  [i k3 bb be4]
  bb = be4;

end

